// TLS3008 based 50 RGB LEDs string test application for 16MHz Arduino
// Library example code
//
// - DonJuanito99 -

#include <TLS3008.h>

#define SDO 11  // Serial Line Out (pin connected to SDI/green wire)
#define FRAMERPTCNT 1 // Number of times to repeat each 50 LEDs frame. Usually works OK with '1'...

TLS3008 tls = TLS3008(SDO); // Create instance of object TL3008. Setup output pin to LEDs.

byte RGBTable[50][3];  // RGB Values Table. Use type casting (byte*) to pass as a pointer to the sendRGBFrame function.

void setup()
 {
   tls.initCom(); // Initilize the communication with the LEDs
 }

 void loop()
 {
   byte ii;
   byte* ptT;
   
   // Setup color values =========================================================================
   ptT = (byte*) &RGBTable;

   for (ii=0;ii<50;ii++)  {
       // We want very bright colors. That's why we only allow 0x00 of 0xFF as RGB values.
       *ptT++ = (byte) (random(2)*255); // R
       *ptT++ = (byte) (random(2)*255); // G
       *ptT++ = (byte) (random(2)*255); // B
   }

   // Send LEDs RGB levels =======================================================================
   for(ii=0;ii<FRAMERPTCNT;ii++)
       tls.sendRGBFrame( (byte*) &RGBTable, 150 );
}

